<?php
/**
 * Fired during plugin activation
 *
 * @link       http://example.com
 * @since      1.0.0
 *
 * @package    Plugin_Name
 * @subpackage Plugin_Name/includes
 */
/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Plugin_Name
 * @subpackage Plugin_Name/includes
 * @author     Your Name <email@example.com>
 */
class CARP_Activator {
	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		/*
		 * Create facebook_pages table
		 */
		$table = $wpdb->prefix.'carp_form_data';
		if ($wpdb->get_var("show tables like '$table'") != $table) {
			$sql = 'CREATE TABLE '.$table.' (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`autoresponder` varchar(255) NOT NULL,
			`list_id` varchar(255) NOT NULL,
			`form_id` varchar(255) NOT NULL,
			`autoresponder_list` varchar(1024),
			`field_selected` varchar(1024),
			`field_disabled` varchar(1024), 
			`is_subscribed` TINYINT(1) NOT NULL DEFAULT 0,';
			$sql .= '`created` timestamp NOT NULL,';
			$sql .= 'UNIQUE KEY `id` (id)
			) '.$charset_collate.';'; 
		} 
		
		$table_name = $wpdb->prefix . 'cfea7_submits'; 
		if ($wpdb->get_var("show tables like '$table'") != $table_name) {
			$create_ss  = "CREATE TABLE IF NOT EXISTS $table_name(
			`submit_time` datetime DEFAULT NULL,
			`form_id` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`entry_id` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`field_name` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`field_value` longtext CHARACTER SET utf8,
			`field_order` int(11) DEFAULT NULL,
			`file` longblob,
			KEY `submit_time_idx` (`submit_time`),
			KEY `field_name_idx` (`field_name`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
			$wpdb->query($create_ss);
		}
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
		
		$table_n = $wpdb->prefix.'carp_template_data';
		if ($wpdb->get_var("show tables like '$table_n'") != $table_n) { 
			$sql1 = 'CREATE TABLE '.$table_n.' (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`autoresponder` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`list_id` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`template_id` varchar(127) CHARACTER SET utf8 DEFAULT NULL,
			`data` varchar(1024) CHARACTER SET utf8 DEFAULT NULL,';
			$sql1 .= '`created` timestamp NOT NULL,';
			$sql1 .= 'UNIQUE KEY `id` (id)
			) '.$charset_collate.';';    
		}  
		dbDelta($sql1);
		$status = array('Aweber' => 'disconnect' , 'Mailchimp' => 'disconnect' , 'GetResponse' => 'disconnect' , 'CampaignMonitor' => 'disconnect'  , 'iContact' => 'disconnect' , 'ConstantContact' => 'disconnect' , 'Verticalresponse' => 'disconnect' , 'E-goi' =>  'disconnect' , 'ImnicaMail' =>  'disconnect' ,'ActiveCampaign' =>'disconnect'  );    
		update_option('carp_subscriber_status',$status);
		update_option("carp_response","false");
	}
}