<?php
class carp_subscriber{
	public function switch_responder( $apikey, $action, $responder ){
		switch($responder){
			case 'Aweber':
				return $this->Aweber( $apikey, $action, $responder );  
			break;
			case 'Mailchimp':
				return $this->Mailchimp( $apikey, $action );
			break;
			case 'GetResponse':
				return $this->GetResponse( $apikey, $action );
			break;
			case 'CampaignMonitor':
				return $this->CampaignMonitor( $apikey, $action );
			break;
			case 'iContact':
				return $this->iContact( $apikey, $action );
			break;
			case 'ConstantContact':
				return $this->ConstantContact( $apikey, $action );
			break;
			case 'Verticalresponse':
				return $this->Verticalresponse( $apikey, $action ); 
			break;
			case 'E-goi':
				return $this->Egoi( $apikey, $action );
			break; 
			case 'ImnicaMail':
				return $this->ImnicaMail( $apikey, $action );  
			break; 
			case 'ActiveCampaign':
				return $this->ActiveCampaign( $apikey, $action );
			break;
		}   
	}
	
	public function Aweber( $apikey, $action, $responder ){   
		
		require_once CARP_PATH . '/subscribers/Aweber/aweber_api.php';
		
		if(isset($apikey['access_secret'])){
			$consumer_key = $apikey['consumer_key'];
			$consumer_secret = $apikey['consumer_secret']; 
			$access_key = $apikey['access_key']; 
			$access_secret = $apikey['access_secret'];
		}
		
		if($action === 'getList'){
			$list = array();

			$descr = '';
			if(!isset($apikey['access_secret'])){
				try{
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($apikey['aweber_code']);
				}catch (AWeberAPIException $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
					if(isset($exc->message))
					{
						$descr = $exc->message;
						$descr = preg_replace('/http.*$/i', '', $descr);	 # strip labs.aweber.com documentation url from error message
						$descr = preg_replace('/[\.\!:]+.*$/i', '', $descr); # strip anything following a . : or ! character
						$descr = '('.$descr.')';

					}
				}catch (AWeberOAuthDataMissing $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
				}catch (AWeberException $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
				}
			}

			if (!$access_secret){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else{
				$aweber = new AWeberAPI($consumer_key, $consumer_secret);
				$account = $aweber->getAccount($access_key, $access_secret);
				$aweber_result = $account->lists;
				if( $aweber_result->data['total_size'] != '' && $aweber_result->data['total_size'] != 0 ){
					foreach ($aweber_result->data['entries'] as $solo_list){
						$list[$solo_list['id']] = $solo_list['name'];
					}
					$result['list'] = $list;
				}else {
					$result = array('error'=>'There is no list in your account.');
				}
				
				if(!isset($apikey['access_secret'])){
					$data = get_option('wpse_subscriber_settings');
					
					$data[$responder] = array(
						'aweber_code' => $apikey['aweber_code'],
						'consumer_key' => $consumer_key,
						'consumer_secret' => $consumer_secret,
						'access_key' => $access_key,
						'access_secret' => $access_secret
					);
					
					update_option('wpse_subscriber_settings', $data);
				}
				
			}
		}
		
		if($action == 'subsCribe'){
			try{

				$email = $_POST['email'];
				$listID = $_POST['listid'];

				$aweber = new AWeberAPI($consumer_key, $consumer_secret);

				$account = $aweber->getAccount($access_key, $access_secret);

				$aweber_list = $listID;
				$list = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $aweber_list);

				$subscriber = array(
					'email' => $email,
					'ip' => $_SERVER['REMOTE_ADDR']
				);

				if (!empty($_POST['name'])){
					$subscriber['name'] = $_POST['name'];
				}else {
					$fname = '';
				}

				$list->subscribers->create($subscriber);
				
				$result = array('success'=>'Subscribe successfully.');

			}catch (AWeberException $e){
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}

		if($action == 'getStatus'){
			$listID = $_POST['list_id'];
			$email = $_POST['email'];
			$bool = false;

			$aweber = new AWeberAPI($consumer_key, $consumer_secret);

			$account = $aweber->getAccount($access_key, $access_secret);

			$aweber_list = $listID;

			$subscribers_collection = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $aweber_list.'/subscribers');

			if($subscribers_collection){
				foreach ($subscribers_collection as $subscriber) {
				    if($subscriber->email == $email && $subscriber->status == 'subscribed'){
				    	$bool = true;
				    	break;
				    }
				}
			}

			if($bool){
				$output = 'Active';
			}else{
				$output = 'Inactive';
			}

			return array('output'=>$output);
		}
		
		return $result;
	}
	
	public function Mailchimp( $apikey, $action ){
		
		require_once  CARP_PATH . '/subscribers/Mailchimp/MCAPI.class.php';
		
		if($action === 'getList'){
			$key = $apikey['api_key'];
			
			$api = new MCAPI( $key );
			$retval = $api->lists();
			
			if (!$api->errorCode){
				if($retval['data'] != 0){
					foreach ($retval['data'] as $v){
						$list[$v['id']] = $v['name'];
					}
					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$key = $apikey['api_key'];
			
			$api = new MCAPI( $key );
			
			$listID = $_POST['listid'];
			
			//print_r($_POST);
			if($_POST['name']){
				$args = array('FNAME' => $_POST['name']);
			}else{
				$args = array();
			}
			
			if(!empty($listID)){
				$api->listSubscribe($listID, $_POST['email'], $args );
			}
			
			if ($api->errorCode == ''){
				$result = array('success'=>'Thank you, please check your email.');
			}elseif($api->errorCode == 214){
				$result = array('success'=>'This email already subscribe.');
			}else{
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
			
			return $result;
			
		}
		
		if($action == 'getStatus'){
			$key = $apikey['api_key'];
			$api = new MCAPI( $key );
			$listID = $_POST['list_id'];
			$email = $_POST['email'];

			$result = $api->listMemberActivity( $listID, $email );

			if($result['success'] == 1 && empty($result['data'][0])){
				$output = 'Active';
			}else{
				$output = 'Inactive';
			}

			return array('output'=>$output);
		}
	}
	
	public function GetResponse( $apikey, $action ){
		
		require_once CARP_PATH . '/subscribers/GetResponse/jsonRPCClient.php';  
		
		if($action === 'getList'){
			$list = array();
			
			$api = new jsonRPCClient('http://api2.getresponse.com'); 
			try{
				$results = $api->get_campaigns($apikey["api_key"]);
				if( count($results) > 0 ) {

					foreach ($results as $k => $v){
						$list[$k] = $v['name'];
					}
					$result['list'] = $list;
				}else {
					$result = array('error'=>'There is no list in your account.'); // When no list found
				}
			}catch (Exception $e){
			   $result = array('error'=>'Error occur may be somethig wrong.'); // Invalid API key
			}
		}
		
		if($action == 'subsCribe'){
			$api = new jsonRPCClient('http://api2.getresponse.com');
			try{
				$listID = $_POST['listid'];
				if(!empty($listID)){
					$args = array(
						'campaign' => $listID,
						'email' => $_POST['email'],
						'cycle_day'=>0,
					);
				}

				if (!empty($_POST['name'])){
					$args['name'] = $_POST['name'];
				}

				$api->add_contact($apikey["api_key"], $args);
				
				$result = array('success'=>'Subscribe successfully.');

			}catch (Exception $e){ 
				//$result = $e;
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}

		if($action == 'getStatus'){
			$listID = $_POST['list_id'];
			$email = $_POST['email'];
			$bool = false;

			$api = new jsonRPCClient('http://api2.getresponse.com');

			$accounts = $api->get_contacts( $apikey["api_key"] );

			$output = "Inactive";

			if($accounts){
				foreach ($accounts as $key => $value) {
					if($value['email'] == $email){
						$output = "Active";						
						break;
					}
				}
			}

			return array('output'=>$output);
		}
		
		return $result;
		
	}
	
	public function CampaignMonitor( $apikey, $action ){
		
		if($action === 'getList'){
			require_once CARP_PATH . '/subscribers/CampaignMonitor/csrest_clients.php';
			$list = array();

			$wrap = new CS_REST_Clients($apikey["client_id"], $apikey["api_key"]);
			$cm_res = $wrap->get_lists();

			if ($cm_res->http_status_code != '200'){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else{

				if( count($cm_res->response) != 0 ){

					foreach ($cm_res->response as $solo_list){
						$list[$solo_list->ListID] = $solo_list->Name;
					}
					$result['list'] = $list;
					
				}
				else {
					$result = array('error'=>'There is no list in your account.');
				}

			}
		}
		
		if($action == 'subsCribe'){
			require_once CARP_PATH . '/subscribers/CampaignMonitor/csrest_subscribers.php';
			$key = $apikey["api_key"];
			$listID = $_POST['listid'];

			if(!empty($listID)){
				$wrap = new CS_REST_Subscribers($listID, $key);
			}

			$args = array(
				'EmailAddress' => $_POST['email'],
				'Resubscribe' => true
			);

			if (!empty($_POST['name'])){
				$args['name'] = $_POST['name'];
			}

			$res = $wrap->add($args);
			
			$result = array('success'=>'Subscribe successfully.');
		}

		if($action == 'getStatus'){
			require_once CARP_PATH . '/subscribers/CampaignMonitor/csrest_subscribers.php';
			$listID = $_POST['list_id'];
			$email = $_POST['email'];
			$key = $apikey["api_key"];

			if(!empty($listID)){
				$wrap = new CS_REST_Subscribers($listID, $key);
			}

			$res = $wrap->get($email);

			$output = "Inactive";

			if($res->was_successful()){
				if($res->response->State == 'Active'){
					$output = "Active";
				}
			}

			return array('output'=>$output);
		}
		
		return $result;
	}
	
	
	public function iContact( $apikey, $action ){
		require_once  CARP_PATH . '/subscribers/iContact/iContactApi.php';
		
		$list = $result = array();
		
		if($action === 'getList'){
			iContactApi::getInstance()->setConfig(array(
				'appId' => $apikey['app_id'],
				'apiPassword' => $apikey['app_password'],
				'apiUsername' => $apikey['login_email']
			));
			$oiContact = iContactApi::getInstance();
			
			try{
				$icontact_res = $oiContact->getLists();

				if( count($icontact_res) > 0 ) {
					foreach ($icontact_res as $solo_list){
						$list[$solo_list->listId] = $solo_list->name;
					}
				}else{
					$result = array('error'=>'There is no list in your account.');
				}

			}catch (Exception $oException){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			$result['list'] = $list;
		}
		
		if($action == 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			
			iContactApi::getInstance()->setConfig(array(
				'appId' => $apikey['app_id'],
				'apiPassword' => $apikey['app_password'], 
				'apiUsername' => $apikey['login_email']
			));
			
			$email = $_POST['email'];
			$listID = $_POST['listid'];
			$oiContact = iContactApi::getInstance();

			if (!empty($_POST['name'])){
				$fname = $_POST['name'];
			}else {
				$fname = '';
			}

			$res1 = $oiContact->addContact($email, null, null, $fname , '' , null, null, null, null, null, null, null, null, null);
			if ($res1->contactId){
				if ($oiContact->subscribeContactToList($res1->contactId, $listID, 'normal')){
					$result = array('success'=>'Subscribe successfully.');
				}
			}
		}

		if($action == 'getStatus'){
			$listID = $_POST['list_id'];
			$email = $_POST['email'];

			iContactApi::getInstance()->setConfig(array(
				'appId' => $apikey['app_id'],
				'apiPassword' => $apikey['app_password'],
				'apiUsername' => $apikey['login_email']
			));

			$oiContact = iContactApi::getInstance();

			$status = $oiContact->getContactWithEmail($email);

			$output = 'Inactive';

			if(!empty($status) && $status[0]->status == 'normal'){
				$output = 'Active';
			}
			return array('output'=>$output);
		}
		
		return $result;
	}
	
	
	public function ConstantContact( $apikey, $action ){   
		require_once  CARP_PATH.'/subscribers/ConstantContact/class.cc.php'; 
		
		if($action === 'getList'){
			$cc = new cc($apikey['username'], $apikey['password']);

            $resultofcc = $cc->get_lists('lists');  
            if ($resultofcc){
				
				if( count($resultofcc) > 0  ){
					
					foreach($resultofcc as $v){
						$list[$v['id']] = $v['Name'];
					}
					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
				
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');  
			$cc = new cc($apikey['username'], $apikey['password']);
			
			$email = $_POST['email'];
			$listID = $_POST['listid'];

			$contact_list = $_POST['listid'];
			$extra_fields = array();
			if (!empty($_POST['name'])){
				$extra_fields['FirstName'] = $_POST['name'];
			}

			$contact = $cc->query_contacts($email);
			//print_r($_POST);			
			if (!$contact){
				//print_r($_POST);
				$new_id = $cc->create_contact($email, $contact_list, $extra_fields);
				if ($new_id){
					$result = array('success'=>'Subscribe successfully.');
				}
			}
			
			return $result;
		}

		if($action == 'getStatus'){
			$listID = $_POST['list_id'];
			$email = $_POST['email'];

			$cc = new cc($apikey['username'], $apikey['password']);   

			$contacts =	$cc->get_list_members($listID);

			$output = 'Inactive';
			for($i=0;$i<count($contacts);$i++){
				if($email == $contacts[$i]['EmailAddress']){
					$output = 'Active';
					break;
				}
			}
			return array('output'=>$output);
		}
	}
	
	
	public function Verticalresponse( $apikey, $action ){
		
		if($action == 'getList'){
			$access_token = $apikey['accesstoken'];
			
			$params = array('access_token'=>$access_token);
			$ch = curl_init();
			$url ='';
			if ($params)
			{
				$url =  ( strpos( $url, '?' ) ? '&' : '?' ) . http_build_query($params, '', '&');
			}

			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_URL, 'https://vrapi.verticalresponse.com/api/v1/lists' . $url);
			$headers = array('Authorization: Bearer ' . $access_token);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$data = curl_exec($ch);
			curl_close($ch);
			$retvals = json_decode($data, true);

			$lists = array();

			if ($retvals){
				if(isset($retvals['items'])) {
					if(count($retvals['items']) > 0) {
						$list = array();
						foreach($retvals['items'] as $retval){
							$list[$retval['attributes']['id']] = $retval['attributes']['name'];
						}
						$result['list'] = $list;
					}else {
						$result = array('error'=>'Error occur may be somethig wrong.');
					}
				}else {
					$result = array('error'=>'Error occur may be somethig wrong.');
				}

			} else {
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
		}
		
		if($action == 'subsCribe'){
			$Verticalresponse_accesstoken = $apikey['accesstoken'];

			$email = $_POST['email'];

			if (!empty($_POST['name'])){
				$fname = $_POST['name'];
			}else {
				$fname = '';
			}
			$listID = $_POST['listid'];

			try{

			   $postData = '';
			   $params = array('email'=>$email);
			   //create name value pairs seperated by &
			   foreach($params as $k => $v)
			   {
				  $postData .= $k . '='.$v.'&';
			   }
			   $postData = rtrim($postData, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL,'https://vrapi.verticalresponse.com/api/v1/lists/'.$listID.'/contacts');
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				$headers = array('Authorization: Bearer ' . $Verticalresponse_accesstoken);
				curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
				$data = curl_exec($ch);
				curl_close($ch);
				$data = json_decode($data, true);
				//print_r($data);
				if(isset($data['success'])){
					$result = array('success'=>'Subscribe successfully.');	 
				}else{
					$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
				}

			} catch (Exception $e){
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}
		
		return $result;
	}
	
	public function Verticalresponse1( $apikey, $action ){       
		
		if($action == 'getList'){
			$list = array();
			if($cf_vr_username && $cf_vr_pass){
				date_default_timezone_set('America/Los_Angeles'); 
				$wsdl = "https://api.verticalresponse.com/wsdl/1.0/VRAPI.wsdl";
				$ses_time = 10;  
				$vr = new SoapClient($wsdl, array (  )  );
				$sid = $vr->login(
					array(
						  'username' => $apikey['username'],
						  'password' => $apikey['password'],
						  'session_duration_minutes' => $ses_time
						  )
				);
				$list_name = "API List: " . time() ; 
				$res = $vr->enumerateLists( array(
					'session_id'         => $sid, 
					'type'               => 'email',
					'include_field_info' => true,
				) );
				if ($res){
					foreach ((array) $res as $v){
						$list[$v->id] = $v->name;
					}
					$result['list'] = $list;
				}else {
					$result = array('error'=>'Error occur may be somethig wrong.');
				}		
			}
			return  $result;     
		}
	}
	
	public function Egoi( $apikey, $action ){  
		require_once CARP_PATH . '/subscribers/e-goi-wrapper-php-0.3.1/Egoi/Factory.php';
		require_once CARP_PATH . '/subscribers/e-goi-wrapper-php-0.3.1/Zend/XmlRpc/Client.php';
		
		if($action === 'getList'){
			$list = array();
			$client = new Zend_XmlRpc_Client('http://api.e-goi.com/v2/xmlrpc.php');
			try{
				//$apikey =  get_option('carp_subscriber_settings')['E-goi']['api_key'];
				$arguments = array(
					"apikey" => $apikey['api_key'] 
				); 
				$results = $client->call('getLists', array($arguments));
				if( count($results) > 0  &&  is_array($results)  ) { 
					foreach ((array)$results as $v){
						//$lists['list'][$v['listnum']] = array($v['title_ref'] => $v['title']);
						$lists[$v['listnum']] =$v['title']; 
					}
					$result['list'] = $lists;
				}else {
					$result = array('error'=>'There is no list in your account.'); // When no list found
				}
			}catch (Exception $e){
			   $result = array('error'=>'Error occur may be somethig wrong.'); // Invalid API key
			}
		}
		
		return $result;
		
	}
	
	public function ImnicaMail( $apikey, $action ){    
		require_once CARP_PATH . '/subscribers/ImnicaMail/imnicamail.php';
		if($action === 'getList'){
			$list = array();
			$imnicamail=new ImnicaMailAutoRegister();
			try{
				$apikey =  get_option('carp_subscriber_settings')['ImnicaMail'];
				$response=$imnicamail->userLogin($apikey['username'],$apikey['password']);
				$lists=$imnicamail->listsGet($response->SessionID);
				$res= $lists->Lists;
				

				if( count($res) > 0 ) {
					foreach ((array)$res as $v){
						$lists[$v->ListID] = $v->Name;
					}
					$result['list'] = $lists;
				}else {
					$result = array('error'=>'There is no list in your account.'); // When no list found
				}
			}catch (Exception $e){
			   $result = array('error'=>'Error occur may be somethig wrong.'); // Invalid API key
			}
		}
		return $result;
		
	}
	
	public function ActiveCampaign( $apikey, $action ){    
		if($action === 'getList'){
			$url = $apikey['api_url'];
			$api_key = $apikey['api_key'];

			$params = array(

				'api_key'      => $api_key,
				'api_action'   => 'list_paginator',
				'api_output'   => 'json',
				'somethingthatwillneverbeused' => '',
				'sort' => '',
				'offset' => 0,
				'limit' => 20,
				'filter' => 0,
				'public' => 0,

			);

			$query = "";
			foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
			$query = rtrim($query, '& ');
			$url = rtrim($url, '/ ');

			if ( !function_exists('curl_init') ) { $result = array('error'=>'Error occur may be somethig wrong.'); }

			if ( $params['api_output'] == 'json' && !function_exists('json_decode') ) {
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			$api = $url . '/admin/api.php?' . $query;

			$request = curl_init($api);
			curl_setopt($request, CURLOPT_HEADER, 0);
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
			$response = (string)curl_exec($request);
			curl_close($request);

			if ( !$response ) {
			   $result = array('error'=>'Error occur may be somethig wrong.');
			}

			$results = json_decode($response);

			if( $results->result_code == 0 ) {
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else {
				if ( $results->cnt == 0 ) {
					$result = array('error'=>'There is no list in your account.');
				}
				else {

					foreach ($results->rows as $solo_list){
						$list_key = $solo_list->id;
						$list_name = $solo_list->name;
						$list[$list_key] = $list_name;
					}
					$result['list'] = $list;
				}
			}
		}
		
		if($action === 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			$url = $apikey['api_url'];
			$api_key = $apikey['api_key'];
			$listID = $_POST['listid'];

			$params = array(
				'api_key'      => $api_key,
				'api_action'   => 'contact_add',
				'api_output'   => 'json'
			);

			if (!empty($_POST['name']))
			{
				$fname = $_POST['name'];
			}
			else {
				$fname = '';
			}

			$post = array(
				'email'                    => $_POST['email'],
				'first_name'               => $fname,
				'tags'                     => 'api',
				'p[1]'                   => $listID,
				'status[1]'              => 1,
				'instantresponders[123]' => 1
			);

			$query = "";
			foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
			$query = rtrim($query, '& ');

			$data = "";
			foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
			$data = rtrim($data, '& ');

			$url = rtrim($url, '/ ');

			$api = $url . '/admin/api.php?' . $query;

			$request = curl_init($api);
			curl_setopt($request, CURLOPT_HEADER, 0);
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($request, CURLOPT_POSTFIELDS, $data);
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
			$response = (string)curl_exec($request);
			curl_close($request);

			if ( $response ) {
				$results = json_decode($response);
				if( $results->result_code != 0) {
					$result = array('success'=>'Subscribe successfully.');
				}
			}
		}

		if($action == 'getStatus'){
			$listID = $_POST['list_id'];
			$email = $_POST['email'];

			$output = "Inactive";

			$url = $apikey['api_url'];

			$params = array(
			    'api_key'      => $apikey['api_key'],
			    'api_action'   => 'contact_view',
			    'api_output'   => 'json',
			    'id'           => $email,
			);

			$query = "";
			foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
			$query = rtrim($query, '& ');

			$url = rtrim($url, '/ ');

			$api = $url . '/admin/api.php?' . $query;

			$request = curl_init($api);
			curl_setopt($request, CURLOPT_HEADER, 0);
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($request, CURLOPT_POSTFIELDS, $data);
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
			$response = (string)curl_exec($request);
			curl_close($request);

			if ( $response ) {
				$results = json_decode($response);
				if( $results->result_code != 0) {
					if($results->status == 1){
						$output = 'Active';
					}
				}
			}
			return array('output'=>$output);
		}
		
		return $result;
	}
}