<?php
/**
 * The public-facing functionality of the plugin.
 *
 * @link       http://example.com
 * @since      1.0.0
 *
 * @package    Plugin_Name
 * @subpackage Plugin_Name/public
 */
/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    Plugin_Name
 * @subpackage Plugin_Name/public
 * @author     Your Name <email@example.com>
 */
class CARP_Public {
	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;
	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;
	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {
		$this->plugin_name = $plugin_name;
		$this->version = $version;
	}
	/**
	 * Register the stylesheets for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_styles() {
		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Plugin_Name_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Plugin_Name_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */
		wp_enqueue_style( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'css/carp-public.css', array(), $this->version, 'all' );
	}
	/**
	 * Register the JavaScript for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_scripts() {
		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Plugin_Name_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Plugin_Name_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */
		wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/carp-public.js', array( 'jquery' ), $this->version, true );
		wp_localize_script( $this->plugin_name,'ajaxobject', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
	}
	
	public function carp_widget_shortcode($atts){  
			wp_enqueue_style( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'css/carp-public.css', array(), $this->version, 'all' );
			wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/carp-public.js', array( 'jquery' ), $this->version, true );
			wp_localize_script( $this->plugin_name,'ajaxobject', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
			$atts = shortcode_atts( array(
				'list' => '',
				'template' => '',
				'autoresponder' => ''
			), $atts, 'CFAW7A' ); 
			global $wpdb;
			$list_id = $atts['list'];
			$template = $atts['template'];
			$atores = $atts['autoresponder'];
			$result = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."carp_template_data WHERE list_id = '".$list_id."' and template_id = '".$template."'  "); 
			if($wpdb->num_rows>0){
				foreach($result as $results){
					$data = json_decode($results->data,true);
					$title = isset($data['carp_templete_title'])?$data['carp_templete_title']:'';
					$btn_txt = isset($data['carp_templete_button_text'])?$data['carp_templete_button_text']:'';;
					$desc = isset($data['carp_templete_popup_desp'])?$data['carp_templete_popup_desp']:'';
					$sub_title = isset($data['carp_templete_popup_subtit'])?$data['carp_templete_popup_subtit']:'';
					$name_placeholder = isset($data['carp_templete_popup_name_ph'])?$data['carp_templete_popup_name_ph']:'';
					$email_placeholder = isset($data['carp_templete_popup_email_ph'])?$data['carp_templete_popup_email_ph']:'';
					$bg_clr = isset($data['carp_templete_bgclr'])?$data['carp_templete_bgclr']:'';
					$bg_txt_clr = isset($data['carp_templete_txt_clr'])?$data['carp_templete_txt_clr']:'';
					$desc_clr = isset($data['carp_templete_popup_desp_clr'])?$data['carp_templete_popup_desp_clr']:'';
					$subtitle_clr = isset($data['carp_templete_popup_subtit_clr'])?$data['carp_templete_popup_subtit_clr']:'';
					$border_clr = isset($data['carp_templete_bdrclr'])?$data['carp_templete_bdrclr']:'';
					$btn_bg_clr = isset($data['carp_templete_btn_bgclr'])?$data['carp_templete_btn_bgclr']:'';
					$btn_txt_clr = isset($data['carp_templete_btn_txtclr'])?$data['carp_templete_btn_txtclr']:'';
					$btn_bdr_clr = isset($data['carp_templete_btn_bdrclr'])?$data['carp_templete_btn_bdrclr']:'';
					$btn_hvr_clr = isset($data['carp_templete_btn_hvrclr'])?$data['carp_templete_btn_hvrclr']:'';
					$btn_hvr_txtclr = isset($data['carp_templete_btn_hvrtxtclr'])?$data['carp_templete_btn_hvrtxtclr']:'';
					$image= isset($data['carp_event_image_upload'])?$data['carp_event_image_upload']:'';
					$logo = isset($data['carp_event_logo_upload'])?$data['carp_event_logo_upload']:'';
					$plh_clr = isset($data['carp_templete_plcclr'])?$data['carp_templete_plcclr']:'';
					$result="";
					
					$result .= '<div class="carp_temp_wrapper">';
					$result .= '<div id="public_template" style="display: none;" >'.$template.'</div>';
					$result .= '<div id="public_plcclr" style="display: none;">'.$plh_clr.'</div>';
					if($template == "temp1"){
						$result .= '<div id="temp1">
							<div class="temp1_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; "> 
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<h1 class="form_heading" data-title="Subscribe Here" style="color:'.$bg_txt_clr.'; ">'.$title.'</h1>
									<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
									<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
									<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'" value="" />
									<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
									<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.'; " />
									<span id="popup_response_err" class="popup_response_err" ></span> 
								</form>
							</div>
						</div>';
					}else if($template == "temp2"){
						$result .= '<div id="temp2">
							<div class="temp2_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<h1 data-title="subscribe to our newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp2_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
					}else if($template == "temp3"){
						$result .= '<div id="temp3">
							<div class="temp3_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">';
								if($logo == ""){
									$result .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/email_t7.png'.' ">';
								}else{
									$result .= '<img src=" '.$logo.' ">';
								}
								
						$result .= '<h1 data-title="subscribe to the newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp3_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
					}else if($template == "temp4"){
						$result .= '<div id="temp4">
							<div class="temp4_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >
								<h3 style="color:'.$subtitle_clr.'; " >'.$sub_title.'</h3>
								<h1 data-title="30% discount" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp4_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div> 
								</form>
							</div>
						</div>';
					}else if($template == "temp5"){
						$result .= '<div id="temp5" >
							<div class="temp5_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<h1  data-title="subscribe to the newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp5_input">
										<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'"  style="color:'.$bg_txt_clr.'; "  />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" style="color:'.$bg_txt_clr.'; "  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.'; border: 1px solid '.$btn_bdr_clr.';  "  />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
						
					}else if($template == "temp6"){
						$result .= '<div id="temp6">
							<div class="temp6_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >
								<div class="temp6_top_wrapper">
									<div class="temp6_icon">';
									if($logo == ""){
										$result .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/envelope_icon_2.png'.' ">';
									}else{
										$result .= '<img src=" '.$logo.' ">';
									}
								$result .= '</div>
									<div class="temp6_heading">
										<h1  data-title="subscribe" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
										<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
									</div>
								</div>
								<div class="temp6_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp6_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp7"){
						$result .= '<div id="temp7">
							<div class="temp7_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<div class="temp7_top_wrapper">
									<div class="temp7_heading">
										<h3 style="color:'.$subtitle_clr.'; ">'.$sub_title.'</h3>
										<h1 data-title="NEWSLETTER" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>      
										<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
									</div>
									<div class="temp7_icon">';
									if($logo == ""){
										$result .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/temp_smily.png'.' ">';
									}else{
										$result .= '<img src=" '.$logo.' ">';
									}
									$result .='</div>
								</div>
								<div class="temp7_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp7_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
									</div>
									<span id="popup_response_err" class="popup_response_err" ></span> 
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp8"){
						$result .= '<div id="temp8">
							<div class="temp8_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; "> 
								<div class="temp8_top_wrapper">
									<div class="temp8_icon">';
									if($logo == ""){
										$result .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/temp_offer.png'.' ">';
									}else{
										$result .= '<img src=" '.$logo.' ">';
									}
									$result .= '</div>
									<div class="temp8_heading"> 
										<h3 style="color:'.$subtitle_clr.'; ">'.$sub_title.'</h3>    
										<h1 data-title="30% off" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
									</div>
								</div>
								<div class="temp8_input_wrapper">
								<p style="color:'.$desc_clr.'; ">'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp8_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp9"){
						$result .= '<div id="temp9" style="background-color:'.$bg_clr.';  border-color:'.$border_clr.';  ">';
						if($image == ''){
							$result .='<div class="temp9_wrapper" >';
						}else{
							$result .='<div class="temp9_wrapper" style="background-image: url('.$image.');">';
						}
						   
								$result .= '<div class="temp9_top_wrapper">           
									<div class="temp9_heading">       
										<h1 data-title="newsletter" style="color:'.$bg_txt_clr.'; "  >'.$title.'</h1>
									</div>
								</div>
								<div class="temp9_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp9_input">
										<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp10"){
						$result .= '<div id="temp10">
							<div class="temp10_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >               
								<div class="temp10_heading">
									<div class="temp10_icon">';
									if($logo == ""){
										$result .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/email_img.png'.' ">';
									}else{
										$result .= '<img src=" '.$logo.' ">';
									}
									$result .= '</div>	 
									<h1 data-title="subscribe" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>  
									<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								</div>
								<div class="temp10_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp10_input">
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="hidden" name="auto_res" id="auto_res" value="'.$atores.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="submit" value="'.$btn_txt.'" class="carp_subs_btn carp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  "  />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>     
						</div>       
					</div>';					
					$result .= '</div>';					
					}
				?>
				<script>
				 jQuery(document).ready(function(){
					jQuery('#<?php echo $template; ?> .carp_subs_btn').hover(function() {
						jQuery( this ).css('background-color', '<?php echo $btn_hvr_clr; ?>'); 
					  }, function() {
						  jQuery( this ).css('background-color', '<?php echo $btn_bg_clr; ?>');
					  });
					  jQuery('#<?php echo $template; ?> .carp_subs_btn').hover(function() {
						jQuery( this ).css('color', '<?php echo $btn_hvr_txtclr; ?>'); 
					  }, function() {
						  jQuery( this ).css('color', '<?php echo $btn_txt_clr; ?>');
					  });
				 });
				</script>
				<?php 
				return $result;	
				
				}					
				
			}
	}
	
	public function temp_form_submit(){
		$list_id = $_POST['temp_form__list_id'];
		$name= $_POST['temp_form_name'];
		$email = $_POST['temp_form_email'];
		$autores = $_POST['temp_form_autors'];
		if(get_option('carp_subscriber_settings')){
			
			if($autores == "Aweber"){
				require_once CARP_PATH . '/subscribers/Aweber/aweber_api.php';				
				$api_key =  get_option('carp_subscriber_settings')['Aweber'];    
				 try{
					$aweber = new AWeberAPI($api_key['consumer_key'], $api_key['consumer_secret']);
					$account = $aweber->getAccount($api_key['access_key'], $api_key['access_secret']);
					$list = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $list_id);
				 }catch (AWeberException $e) {
				}
				if($name != ''){ 
					$subscriber = array( 
						'email' =>$email,
						'name' => $name,
						'ip' => $_SERVER['REMOTE_ADDR']
					);
				}else{
					$subscriber = array( 
						'email' => $email,
						'ip' => $_SERVER['REMOTE_ADDR']
					);
				}
				try{
					$list->subscribers->create($subscriber); 
				}catch (AWeberException $e){
						echo $e->getMessage();  
				}
				echo "success";      
			}else if($autores == "Mailchimp"){
				require_once CARP_PATH . '/subscribers/Mailchimp/MCAPI.class.php';
				$api_key =  get_option('carp_subscriber_settings')['Mailchimp']['api_key'];
				$mcapi = new MCAPI($api_key);
				$merge_vars['FNAME'] = $name; 
				if ($list_id != '') {
					$mailchimplist = $list_id;
					if($name != ''){
						$retval = $mcapi->listSubscribe($mailchimplist, $email, $merge_vars); 
					}else{
						$retval = $mcapi->listSubscribe($mailchimplist, $email); 
					}
				}
				if ($mcapi->errorCode) {
					echo $mcapi->errorCode;
				} else { 
					echo "success";
				}
			}else if($autores == "GetResponse"){
				require_once CARP_PATH . '/subscribers/GetResponse/jsonRPCClient.php'; 
				$api_key =  get_option('carp_subscriber_settings')['GetResponse']['api_key'];
				$api = new jsonRPCClient('http://api2.getresponse.com');
				try{
				if(!empty($list_id)){
					$args = array(
						'campaign' => $list_id,
						'email' => $email,
					);}
					if (!empty($name))
					{
						$args['name'] = $name;
					}
					$res = $api->add_contact($api_key, $args);
					$Done = 1;
					//var_dump($res); 
					echo "success";
				}catch (Exception $e){
					echo $e->getMessage();			
				}
				 
			}else if($autores == "CampaignMonitor"){
				require_once CARP_PATH . '/subscribers/CampaignMonitor/csrest_subscribers.php'; 
				$api_key =  get_option('carp_subscriber_settings')['CampaignMonitor']['api_key'];
				if(!empty($list_id)){
					$wrap = new CS_REST_Subscribers($list_id, $api_key);
				}
				
				$args = array(
					'EmailAddress' => $email,
					'Resubscribe' => true
				);
				if (!empty($name)){
					$args['Name'] = $name;
				}
		       $res = $wrap->add($args);
				if ($res->was_successful()){
					$Done = 1;
					echo "success";
				}else{ 
					// We'll send this by email. 
					echo 'Failed with code ' . $res->http_status_code . "\n<br /><pre>"; 
				}
			} else if( $autores == "iContact" ){
				require_once CARP_PATH . '/subscribers/iContact/iContactApi.php';       
				$api_key =  get_option('carp_subscriber_settings')['iContact']; 
				iContactApi::getInstance()->setConfig(array(
					'appId' => $api_key['app_id'], 
					'apiPassword' => $api_key['app_password'],
					'apiUsername' => $api_key['login_email']                 
				)); 
				if(!empty($list_id)){
					$arp_setting['cf_ic_list']=$list_id;  
				}
				$oiContact = iContactApi::getInstance();
				$res1 = $oiContact->addContact($email, null, null, (isset($name) ? $name : ''), '', null, null, null, null, null, null, null, null, null);
				if ($res1->contactId){ 
					if ($oiContact->subscribeContactToList($res1->contactId, $arp_setting['cf_ic_list'], 'normal')){    
						$Done = 1;
						echo "success";
					}
				}else{
					// Error...
					// We'll send this by email.
				}
			}else if( $autores == "E-goi" ){  
					require_once CARP_PATH . '/subscribers/e-goi-wrapper-php-0.3.1/Zend/XmlRpc/Client.php';
					$api_key =  get_option('carp_subscriber_settings')['E-goi']['api_key']; 
					$params = array( 'apikey'    => $api_key, 'listID' => $list_id);  
					$params['email'] = $email;
					$params['first_name'] = $name;		
					
					$client = new Zend_XmlRpc_Client('http://api.e-goi.com/v2/xmlrpc.php');
					$result = $client->call('addSubscriber', array($params)); 
					if(isset($result["ERROR"])){
						echo $result["ERROR"];
					}else{
						echo "success";
						$Done = 1; 
					}
			}else if($autores == "ConstantContact"){
				require_once CARP_PATH . '/subscribers/ConstantContact/class.cc.php';
				$api_key =  get_option('carp_subscriber_settings')['ConstantContact']; 
				$cc = new cc($api_key['username'], $api_key['password']);
				if(!empty($list_id)){
					$contact_list =$list_id; }
				$extra_fields = array();
				if (!empty($name))
				{
					$extra_fields['FirstName'] = $name;
				}
				$contact = $cc->query_contacts($email);
				if ($contact){
					$status = $cc->update_contact($contact['id'], $email, $contact_list, $extra_fields);
					if ($status){
						$Done = 1;
						echo "success";
					}else{
						// Error...
						// We'll send this by email.
						// if an error occurs we can debug it any various ways
						// show a simple error to the user
						//echo "Update Contact Operation failed: " . $cc->http_get_response_code_error($cc->http_response_code);
						// or output the last http request and response strings, for debugging only
						//$cc->show_last_connection();
						// usually the http_response_body will contain a more descriptive error to help debug
						//if ($cc->http_response_body)echo '<p>' . $cc->http_response_body . '</p>';
					}
				}else{
					$new_id = $cc->create_contact($email, $contact_list, $extra_fields);
					if ($new_id){
						$Done = 1;
						echo "success";    
					}else{
						// Error...
						// We'll send this by email.
						// if an error occurs we can debug it any various ways
						// show a simple error to the user
						//echo "Create Contact Operation failed: " . $cc->http_get_response_code_error($cc->http_response_code);
						// or output the last http request and response strings, for debugging only
						//$cc->show_last_connection();
						// usually the http_response_body will contain a more descriptive error to help debug
						//if ($cc->http_response_body)	echo '<p>' . $cc->http_response_body . '</p>';
					}
				}
			}else if($autores == "Verticalresponse"){
				$api_key =  get_option('carp_subscriber_settings')['Verticalresponse']; 
				$Verticalresponse_accesstoken = $api_key['accesstoken'];
				if (!empty($name)){
					$fname = $name;
				}else {
					$fname = '';
				}
				try{
				   $postData = '';
				   $postData1 = '';
				   $params = array(
						'email'=>$email , 
						'first_name'=>$fname,   
					);
					$postData = json_encode($params);  
					$ch = curl_init();
					curl_setopt($ch,CURLOPT_URL,'https://vrapi.verticalresponse.com/api/v1/lists/'.$list_id.'/contacts'); 
					curl_setopt($ch, CURLOPT_POST, 1);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					$headers = array('Authorization: Bearer ' . $Verticalresponse_accesstoken,'Content-Type: application/json'); 
					curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
					$data = curl_exec($ch);
					curl_close($ch);
					$data = json_decode($data, true);
					if(isset($data['success'])){
						echo "success";
					}else{
						echo 'Subscribe unsuccessfully, please contact administrator for more information';
					}
				} catch (Exception $e){
					echo 'Subscribe unsuccessfully, please contact administrator for more information';
				}     
				$Done = 1;    	    
			} else if($autores == "ImnicaMail"){
				require_once CARP_PATH . '/subscribers/ImnicaMail/imnicamail.php';
				if(get_option('carp_subscriber_settings')){ 
					if(!empty($combined_cf_autores)){
						$api_key =  get_option('carp_subscriber_settings')['ImnicaMail']; 
						if(!empty($list_id)){
							$list_ids=$list_id; 
						}
						$imnicamail=new ImnicaMailAutoRegister();
						$response=$imnicamail->userLogin($api_key['username'],$api_key['password']);
						$imnicamail->subscriberSubscribe($response->SessionID,$email,$custom_variables = array());
						$Done=1;   
						echo "success";
					} 
				}
			}else if($autores == "ActiveCampaign"){
				if(get_option('carp_subscriber_settings')){ 
					$api_key =  get_option('carp_subscriber_settings')['ActiveCampaign'];   
					if(!empty($list_id)){
						$list_ids=$list_id; 
					}
					$url = $api_key['api_url'];
					$params = array(
						'api_key'      => $api_key['api_key'],  
						'api_action'   => 'contact_add',
						'api_output'   => 'json'
					);
					if (!empty($name)){
						$fname = $name;
					} 
					else {
						$fname = '';
					}
					$post = array(
						'email'                    => $email,
						'first_name'               => $fname,
						'tags'                     => 'api',
						'p[1]'                   => $list_ids,
						'status[1]'              => 1,
						'instantresponders[123]' => 1
					);
					$query = "";
					foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';      
					$query = rtrim($query, '& ');
					$data = "";
					foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
					$data = rtrim($data, '& ');
					$url = rtrim($url, '/ ');
					$api = $url . '/admin/api.php?' . $query;
					$request = curl_init($api);
					curl_setopt($request, CURLOPT_HEADER, 0);
					curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($request, CURLOPT_POSTFIELDS, $data);
					curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
					$response = (string)curl_exec($request);
					curl_close($request);
					if ( $response ) {
						$results = json_decode($response);
						if( $results->result_code != 0) {
							echo "success";
						}
					} 
				}
			}
			die();
		}
		
	}
	
	public function carp_aweber_cf7_submit($wpar){ 
		global $wpdb;
		$submission = WPCF7_Submission::get_instance();
        if ($submission) {
            $formdata = $submission->get_posted_data();
        }
        $i = 0;
        // date_default_timezone_set('Asia/Kolkata');
        $today = date("Y-m-d H:i:s");
        $table_name  = $wpdb->prefix . 'cfea7_submits';
        $entry = $wpdb->get_results("SELECT MAX(entry_id) AS maxid FROM ".$table_name."");
        $final_entry = $entry[0]->maxid+1;				
        $skipvalue   = array(
            "_wpcf7_version",
            "_wpcf7_is_ajax_call",
            "_wpcf7_locale",
            "_wpcf7_unit_tag",
            "_wpnonce"
        ); 
		
       for ($j = 0; $j < count($skipvalue); $j++) {
          if (array_key_exists($skipvalue[$j], $formdata)) { 
               unset($formdata[$skipvalue[$j]]);
           } 
        } 
		$formdata = array_filter($formdata);
		$i =0;
		$newdata="";
        foreach ($formdata as $fieldname => $fieldvalue) {  
            if ($i != 0) {
                $newdata .= ",";
            }
           if (is_array($fieldvalue)) {
                $fieldvalue = $fieldvalue[0];
            } else {
                $fieldvalue = $fieldvalue;
            }
            $newdata .= '("' . $today . '","' . $formdata['_wpcf7'] . '","' . $final_entry . '","' . $fieldname . '","' . $fieldvalue . '","' . $i . '","")'; 
            $i++; 
        } 
        $table_name = $wpdb->prefix . 'cfea7_submits';
        $wpdb->query('INSERT INTO ' . $table_name . '(`submit_time`,`form_id`,`entry_id`,`field_name`, `field_value`,`field_order`,`file`) VALUES ' . $newdata . ''); 
        if ($formdata['_wpcf7']) {
        	$resultsss = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."carp_form_data WHERE form_id = '".$formdata['_wpcf7']."' ");
			$arlists =array();
			if($wpdb->num_rows>0){
				$i = 0;
				foreach($resultsss as $results){
					$arlists = $resultsss[$i]->list_id;
					$select_cf_fields = json_decode($resultsss[$i]->field_selected);
					$autoresponder = $resultsss[$i]->autoresponder;
					for ($b = 0; $b < count($select_cf_fields); $b++) {
						if (array_key_exists($select_cf_fields[$b], $formdata)) {  
							$carp_formfield[]  = $formdata[$select_cf_fields[$b]];
					   } 
					}
			 
					$select_autores_fields = json_decode($resultsss[$i]->autoresponder_list);
					
					$combined_cf_autoresponder = array_combine(array_intersect_key($select_autores_fields, $carp_formfield), array_intersect_key($carp_formfield, $select_autores_fields));
					if($autoresponder == "Aweber" ){
						if(get_option('carp_subscriber_status')['Aweber'] =="connect"){
							echo $this->contactformarsubmitter_onaweber($combined_cf_autoresponder,$autoresponder, $arlists);  
						}
					}else if($autoresponder == "Mailchimp"){
						if(get_option('carp_subscriber_status')['Mailchimp'] =="connect"){
							echo $this->contactformarsubmitter_onmailchimp($combined_cf_autoresponder,$autoresponder, $arlists);  
						}
					}else if($autoresponder == "GetResponse"){
						if(get_option('carp_subscriber_status')['GetResponse'] =="connect"){  
							echo $this->contactformarsubmitter_ongetresponse($combined_cf_autoresponder,$autoresponder, $arlists);      
						}
					}else if($autoresponder == "CampaignMonitor"){
						if(get_option('carp_subscriber_status')['CampaignMonitor'] =="connect"){
							echo $this->contactformarsubmitter_oncompaignmoniter($combined_cf_autoresponder,$autoresponder, $arlists);  
						}
					}else if($autoresponder == "iContact"){
						if(get_option('carp_subscriber_status')['iContact'] =="connect"){
							echo $this->contactformarsubmitter_onicontact($combined_cf_autoresponder,$autoresponder, $arlists);  
						}
					}else if($autoresponder == "E-goi"){
						if(get_option('carp_subscriber_status')['E-goi'] =="connect"){
							echo $this->contactformarsubmitter_onegoi($combined_cf_autoresponder,$autoresponder, $arlists);   
						}
					}else if($autoresponder == "ConstantContact"){
						if(get_option('carp_subscriber_status')['ConstantContact'] =="connect"){
							echo $this->contactformarsubmitter_onconstantcontact($combined_cf_autoresponder,$autoresponder, $arlists);   
						}
					}else if($autoresponder == "Verticalresponse"){
						if(get_option('carp_subscriber_status')['Verticalresponse'] =="connect"){
							echo $this->contactformarsubmitter_onVerticalresponse($combined_cf_autoresponder,$autoresponder, $arlists);    
						}
					}else if($autoresponder == "ImnicaMail"){  
						if(get_option('carp_subscriber_status')['ImnicaMail'] =="connect"){
							echo $this->contactformarsubmitter_onimnicamail($combined_cf_autoresponder,$autoresponder, $arlists);   
						}
					}else if($autoresponder == "ActiveCampaign"){  
						if(get_option('carp_subscriber_status')['ActiveCampaign'] =="connect"){
							echo $this->contactformarsubmitter_onactivecompaign($combined_cf_autoresponder,$autoresponder, $arlists);   
						}
					}
					$i++;
				} 
			} 	
        } 
		//return $currentformInstance; 
	} 
	
	public function contactformarsubmitter_onaweber($combined_cf_autores, $autoresponder = '', $listid = ''){
	    global $wpdb; 
		require_once CARP_PATH . '/subscribers/Aweber/aweber_api.php';
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['Aweber'];    
				 try{
					$aweber = new AWeberAPI($api_key['consumer_key'], $api_key['consumer_secret']);
					$account = $aweber->getAccount($api_key['access_key'], $api_key['access_secret']);
					$list = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $listid);
				 }catch (AWeberException $e) {
				}			 
				
				foreach($combined_cf_autores as $k=>$v){					
					if($k != 'EMAIL' ){
						$merge_vars[$k] = $v;
					}
				}
				if(!empty($merge_vars)){ 
					$subscriber = array( 
						'email' => $combined_cf_autores['EMAIL'],
						'custom_fields' => $merge_vars,
						'ip' => $_SERVER['REMOTE_ADDR']
					);
				}else{
					$subscriber = array( 
						'email' => $combined_cf_autores['EMAIL'],
						'ip' => $_SERVER['REMOTE_ADDR']
					);
				}
				
				if (!empty($combined_cf_autores['name'])){ 
					$subscriber['name'] = $combined_cf_autores['name'];  
				} 
				
				try {
					$list->subscribers->create($subscriber);   
				}catch(Exception $e){
				}					
				$Done = 1; 
			}
		}
	}
	
	public function contactformarsubmitter_onmailchimp($combined_cf_autores, $autoresponder = '', $listid = ''){
	    global $wpdb;  
		require_once CARP_PATH . '/subscribers/Mailchimp/MCAPI.class.php';  
		$result         = array(); 
		$errors         = array();
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['Mailchimp']['api_key'];
				$mcapi = new MCAPI($api_key);
				$cm_email = $combined_cf_autores['EMAIL'];
				
				foreach($combined_cf_autores as $k=>$v){					
					if($k != 'EMAIL' ){
						$merge_vars[$k] = $v;
					}
				}
				if ($listid != '') {
					$mailchimplist = $listid;
					$retval        = $mcapi->listSubscribe($mailchimplist, $cm_email, $merge_vars); 
				}
				if ($mcapi->errorCode) {
				} else { 
					$Done = 1; 
				} 
				
			}
		}
	}
	
	public function contactformarsubmitter_ongetresponse1($combined_cf_autores, $autoresponder = '', $listid = ''){
		require_once CARP_PATH . '/subscribers/GetResponse/GetResponseAPI3.class.php';                  
	    global $wpdb;  
		$result         = array(); 
		$errors         = array();
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['GetResponse']['api_key'];
				$api = new GetResponse($api_key); 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				
				try{
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
						$result[]=array( 'customFieldId' => $k ,   'value' => $v );
					}  
				}
				if(!empty($listid)){
					$args = array(
						'email' => $cm_email,
						'campaign' => array("campaignId" => $listid ),     
						//'customFieldValues' =>  $result   
					);
				}
				if (!empty($name)){
					$args['name'] = $name;     
				}
				
				$res = $api->addContact($args);  
				update_option("new4",$res);
				$Done = 1;
				}catch (Exception $e){
				}	
			} 
		}
	}
	
	public function contactformarsubmitter_ongetresponse($combined_cf_autores, $autoresponder = '', $listid = ''){
		require_once CARP_PATH . '/subscribers/GetResponse/jsonRPCClient.php';   
	    global $wpdb;  
		$result         = array(); 
		$errors         = array();
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['GetResponse']['api_key'];
				$api = new jsonRPCClient('http://api2.getresponse.com');
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				
				try{
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
					    $result[]=array( 'name' => $k ,   'content' => $v );   
					}  
				}
				if(!empty($listid)){
					$args = array(
						'campaign' => $listid,
						'email' => $cm_email,
						'customs' => $result 
					);
				}
				if (!empty($name)){
					$args['name'] = $name;    
				}
				$res = $api->add_contact($api_key, $args);  
				$Done = 1;
				}catch (Exception $e){
					// Error...  
					// We'll send this by email.
					//die($e->getMessage());
				}	
			} 
		}
	}
	
	public function contactformarsubmitter_oncompaignmoniter($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb;
		require_once CARP_PATH . '/subscribers/CampaignMonitor/csrest_subscribers.php';
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['CampaignMonitor']['api_key']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				if(!empty($listid)){
					$wrap = new CS_REST_Subscribers($listid, $api_key);
				}
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
						//$merge_vars[$k] = $v;
						$result[]=array( 'Key' => $k ,   'Value' => $v ); 
					}  
				}
				$args = array(
					'EmailAddress' => $cm_email,  
					'Resubscribe' => true,
					'CustomFields' => $result          
				);
				if (!empty($name)){             
					$args['Name'] = $name;
				}
				
				$res = $wrap->add($args);  
				if ($res->was_successful()){
					$Done = 1;
					//echo "Subscribed with code " . $res->http_status_code;       
				}else{
					// Error...
					// We'll send this by email.
					//echo 'Failed with code ' . $res->http_status_code . "\n<br /><pre>";
					//var_dump($res->response);
					//echo '</pre>';
				}
			} 
		}
	}  
	
	public function contactformarsubmitter_onicontact($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb; 
		require_once CARP_PATH . '/subscribers/iContact/iContactApi.php'; 		
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['iContact']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				iContactApi::getInstance()->setConfig(array(
					'appId' => $api_key['app_id'], 
					'apiPassword' => $api_key['app_password'],
					'apiUsername' => $api_key['login_email']                 
				)); 
				if(!empty($listid)){
					$arp_setting['cf_ic_list']=$listid; 
				}
				$arr = array();
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
						$arr[$k] = $v;  
					}  
				}
				$oiContact = iContactApi::getInstance();
				$res1 = $oiContact->addContact($cm_email, null, null, (isset($name) ? $name : ''), (isset($name) ? '' : ''), null, null, null, null, null, null, null, null, null,$arr);           
				if ($res1->contactId){
					if ($oiContact->subscribeContactToList($res1->contactId, $arp_setting['cf_ic_list'], 'normal')){    
						$Done = 1;
					}
				}else{
					// Error...
					// We'll send this by email.
				}
				
			} 
		}
	}
	
	public function contactformarsubmitter_onegoi($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb; 
		require_once CARP_PATH . '/subscribers/e-goi-wrapper-php-0.3.1/Zend/XmlRpc/Client.php';
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['E-goi']['api_key']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				
				$params = array( 'apikey'    => $api_key, 'listID' => $listid);
				$params['email'] = $cm_email;
				$params['first_name'] = $name;		
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
						$params['extra_'.$k] = $v; 
					}  
				}
				
				$client = new Zend_XmlRpc_Client('http://api.e-goi.com/v2/xmlrpc.php');
				$result = $client->call('addSubscriber', array($params));     
				$Done = 1; 
				
			} 
		}
	}
	
	public function contactformarsubmitter_onconstantcontact($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb; 
		require_once CARP_PATH . '/subscribers/ConstantContact/class.cc.php';
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['ConstantContact']; 
				$cc = new cc($api_key['username'], $api_key['password']);
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				
				if(!empty($listid)){
					$contact_list =$listid; }
				$extra_fields = array();
				if (!empty($name))
				{
					$extra_fields['FirstName'] = $name;
				}
				foreach($combined_cf_autores as $k=>$v){					
					if($k != "EMAIL" && $k != "name"){  
						$extra_fields[$k] = $v;  
					}  
				}  
				$contact = $cc->query_contacts($cm_email);
				if ($contact){
					$status = $cc->update_contact($contact['id'], $cm_email, $contact_list, $extra_fields);
					if ($status){
						$Done = 1;
					}else{
						// Error...
						// We'll send this by email.
						// if an error occurs we can debug it any various ways
						// show a simple error to the user
						//echo "Update Contact Operation failed: " . $cc->http_get_response_code_error($cc->http_response_code);
						// or output the last http request and response strings, for debugging only
						//$cc->show_last_connection();
						// usually the http_response_body will contain a more descriptive error to help debug
						//if ($cc->http_response_body)echo '<p>' . $cc->http_response_body . '</p>';
					}
				}else{
					$new_id = $cc->create_contact($cm_email, $contact_list, $extra_fields);
					if ($new_id){
						$Done = 1;
					}else{
					}
				}
			} 
		}
	}
	
	public function contactformarsubmitter_onVerticalresponse($combined_cf_autores, $autoresponder = '', $listidsff=''){
		global $wpdb; 
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['Verticalresponse']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				$Verticalresponse_accesstoken = $api_key['accesstoken'];
				if (!empty($name)){
					$fname = $name;
				}else {
					$fname = '';
				}
				try{
				   $postData = '';
				   $postData1 = '';
				    foreach($combined_cf_autores as $k=>$v){					
						if($k != "EMAIL" && $k != "name"){  
							$result[$k] = $v;   
						}  
					}  
					update_option("new1",json_encode($result));
				   $params = array(
						'email'=>$cm_email , 
						'first_name'=>$fname,  
						'custom' =>$result,  
					);
					$postData = json_encode($params);  
					$ch = curl_init();
					curl_setopt($ch,CURLOPT_URL,'https://vrapi.verticalresponse.com/api/v1/lists/'.$listidsff.'/contacts'); 
					curl_setopt($ch, CURLOPT_POST, 1);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					$headers = array('Authorization: Bearer ' . $Verticalresponse_accesstoken,'Content-Type: application/json'); 
					curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
					$data = curl_exec($ch);
					curl_close($ch);
					$data = json_decode($data, true);
					if(isset($data['success'])){
						$result = array('success'=>'Subscribe successfully.');	 
					}else{
						$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
					}
				} catch (Exception $e){
					$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
				}     
				$Done = 1;
			} 
		}
	}
	
	public function contactformarsubmitter_onimnicamail($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb; 
		require_once CARP_PATH . '/subscribers/ImnicaMail/imnicamail.php';
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['ConstantContact']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				
				if(!empty($listid)){
					$list_ids=$listid; 
				}
				$imnicamail=new ImnicaMailAutoRegister();
				$response=$imnicamail->userLogin($api_key['username'],$api_key['password']);
				$imnicamail->subscriberSubscribe($response->SessionID,$cm_email,$custom_variables = array());
				$Done=1;  
			} 
		}
	}
	
	public function contactformarsubmitter_onactivecompaign($combined_cf_autores, $autoresponder = '', $listid = ''){
		global $wpdb; 
		if(get_option('carp_subscriber_settings')){ 
			if(!empty($combined_cf_autores)){
				$api_key =  get_option('carp_subscriber_settings')['ActiveCampaign']; 
				$cm_email = $combined_cf_autores['EMAIL'];
				$name = $combined_cf_autores['name'];
				$url = $api_key['api_url'];
				$params = array(
					'api_key'      => $api_key['api_key'],  
					'api_action'   => 'contact_add',
					'api_output'   => 'json'
				);
				if (!empty($_POST['name']))
				{
					$fname = $name;
				}
				else {
					$fname = '';
				}
				$post = array(
					'email'                    => $cm_email,
					'first_name'               => $fname,
					'tags'                     => 'api',
					'p[1]'                   => $listid,
					'status[1]'              => 1,
					'instantresponders[123]' => 1
				);
				$query = "";
				foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
				$query = rtrim($query, '& ');
				$data = "";
				foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
				$data = rtrim($data, '& ');
				$url = rtrim($url, '/ ');
				$api = $url . '/admin/api.php?' . $query;
				$request = curl_init($api);
				curl_setopt($request, CURLOPT_HEADER, 0);
				curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($request, CURLOPT_POSTFIELDS, $data);
				curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
				$response = (string)curl_exec($request);
				curl_close($request);
				if ( $response ) {
					$results = json_decode($response);
					if( $results->result_code != 0) {
						$result = array('success'=>'Subscribe successfully.');
						$Done=1;   
					}
				} 
			} 
		}
	}
}