<?php
    
    if (!class_exists('ImnicaMailAutoRegister')) {
        
        class ImnicaMailAutoRegister {
            var $options = null;
            var $page_hooks = array();
            var $imnicamail_url = 'http://www.imnicamail.com/v4';
            var $wp_variables = array(
                'first_name'    => 'First Name',
                'last_name'     => 'Last Name',
                'nickname'      => 'Nickname',
                'aim'           => 'AOL Instant Messenger',
                'yim'           => 'Yahoo Instant Messenger',
                'jabber'        => 'Google Talk'
            );
            
            /**
            * Constructor.
            */
            
            function __construct() {
              
            }    
            
               
            function subscriberSubscribe($session_id, $list_id, $email, $custom_variables = array()) {
                $post_parameters = array();
                $post_parameters[] = "Command=Subscriber.Subscribe";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "SessionID={$session_id}";
                $post_parameters[] = "ListID={$list_id}";
                $post_parameters[] = "EmailAddress={$email}";
                $post_parameters[] = "IPAddress={$_SERVER['REMOTE_ADDR']}";
                
                foreach ($custom_variables as $id => $value) {
                    $post_parameters[] = "CustomField{$id}={$value}";
                }

                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters);
                
                if (empty($response[0])) {           
                    return false;
                } else {
                    return json_decode($response[1]);      
                }
            }
            
            
            /**
            * Check the login details of the user.
            * @return mixed
            */
            
            function userLogin($username = null, $password = null) {                                                             
                $un = isset($username) ? $username :  $this->options->values['login']['username'];
                $pw = isset($password) ? $password :  $this->options->values['login']['password'];
                
                $post_parameters = array();
                $post_parameters[] = "Command=User.Login";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "Username={$un}";
                $post_parameters[] = "Password={$pw}";
                
                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters);
                
                if (empty($response[0])) {
                    return false;
                } else {
                    $response_1 = json_decode($response[1]);
                    
                   
                    
                    return $response_1;
                }   
            } 
            
            
            /**
            * Ajax user login.
            */
            
            function ajaxUserLogin() {
                $username = $_POST['data']['username'];
                $password = $_POST['data']['password']; 
                $response = $this->userLogin($username, $password);
                die(json_encode($response));
            }                      
            
            
            /**
            * Ajax save list id.
            */
            
            function ajaxSaveList() {
                $list_id = $_POST['data']['list_id'];
                $this->options->values['list']['id'] = $list_id;
                $this->options->save();  
                 
                die(json_encode(array(
                    'Success' => true
                )));     
            }                      
            
            
            /**
            * Get lists from server.
            * 
            * @param string $session_id
            * @return mixed
            */
            
            function listsGet($session_id) {
                $post_parameters = array();
                $post_parameters[] = "Command=Lists.Get";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "SessionID={$session_id}";
                $post_parameters[] = "OrderField=ListID";
                $post_parameters[] = "OrderType=ASC";

                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters);    
                
                if (empty($response[0])) {
                    return false;
                } else {
                    return json_decode($response[1]);                        
                }
            }   
            
            
            /**
            * Ajax listsGet.
            */
            
            function ajaxListsGet() {
                $session_id = $_POST['data']['session_id'];
                $response = $this->listsGet($session_id);
                die(json_encode($response));
            }               
            
            
            /**
            * Get custom fields from server.
            * 
            * @param mixed $session_id
            * @return mixed
            */
            
            function customFieldsGet($session_id) {
                $post_parameters = array();
                $post_parameters[] = "Command=CustomFields.Get";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "SessionID={$session_id}";
                $post_parameters[] = "SubscriberListID={$this->options->values['list']['id']}";
                $post_parameters[] = "OrderField=FieldName";
                $post_parameters[] = "OrderType=ASC";

                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters);
                
                if (empty($response[0])) {
                    return false;
                } else {
                    return json_decode($response[1]);                        
                }
            }
            
            
            /**
            * Ajax customFieldsGet.
            */
            
            function ajaxCustomFieldsGet() {
                $session_id = $_POST['data']['session_id'];
                $response = $this->customFieldsGet($session_id);
                die(json_encode($response));
            }
            
            
          
            function subscriberGet($session_id, $email) {
                $post_parameters = array();
                $post_parameters[] = "Command=Subscriber.Get";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "SessionID={$session_id}";
                $post_parameters[] = "EmailAddress={$email}";
                $post_parameters[] = "ListID={$this->options->values['list']['id']}";

                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters);
                
                if (empty($response[0])) {
                    return false;
                } else {
                    return json_decode($response[1]);                        
                }  
            }
            
            
          
            
            function subscriberUpdate($session_id, $subscriber_id, $subscriber_email, $custom_fields) {
                $post_parameters = array();
                $post_parameters[] = "SessionID={$session_id}";
                $post_parameters[] = "Command=Subscriber.Update";
                $post_parameters[] = "ResponseFormat=JSON";
                $post_parameters[] = "SubscriberID={$subscriber_id}";
                $post_parameters[] = "SubscriberListID={$this->options->values['list']['id']}";
                $post_parameters[] = "EmailAddress={$subscriber_email}";
                $post_parameters[] = "Access=admin";

                foreach ($custom_fields as $custom_field_id => $wp_user_meta_value) {
                    $post_parameters[] = "Fields[CustomField{$custom_field_id}]={$wp_user_meta_value}";    
                } 

                $response = $this->postData("{$this->imnicamail_url}/api.php?", $post_parameters, 'POST', false, '', '', 3600);
//                var_dump($response);
                
                if (empty($response[0])) {
                    return false;
                } else {
                    return json_decode($response[1]);                        
                }
            }
            
                   
            function postData($URL, $post_parameters, $HTTPRequestType = 'POST', $HTTPAuth = false, $HTTPAuthUsername = '', $HTTPAuthPassword = '', $ConnectTimeOutSeconds = 60, $ReturnHeaders = false) {
                $PostParameters = implode('&', $post_parameters);
            
                $CurlHandler = curl_init();
                curl_setopt($CurlHandler, CURLOPT_URL, $URL);

                if ($HTTPRequestType == 'GET') {
                    curl_setopt($CurlHandler, CURLOPT_HTTPGET, true);
                } elseif ($HTTPRequestType == 'PUT') {
                    curl_setopt($CurlHandler, CURLOPT_PUT, true);
                } elseif ($HTTPRequestType == 'DELETE') {
                    curl_setopt($CurlHandler, CURLOPT_CUSTOMREQUEST, 'DELETE');
                } else {
                    curl_setopt($CurlHandler, CURLOPT_POST, true);
                    curl_setopt($CurlHandler, CURLOPT_POSTFIELDS, $PostParameters);
                }

                curl_setopt($CurlHandler, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($CurlHandler, CURLOPT_CONNECTTIMEOUT, $ConnectTimeOutSeconds);
                curl_setopt($CurlHandler, CURLOPT_TIMEOUT, $ConnectTimeOutSeconds);
                curl_setopt($CurlHandler, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3');

                if ((ini_get('safe_mode') != false) && (ini_get('open_basedir') != false)) {
                    curl_setopt($CurlHandler, CURLOPT_FOLLOWLOCATION, true);
                }

                if ($ReturnHeaders == true) {
                    curl_setopt($CurlHandler, CURLOPT_HEADER, true);
                } else {
                    curl_setopt($CurlHandler, CURLOPT_HEADER, false);
                }

                if ($HTTPAuth == true) {
                    curl_setopt($CurlHandler, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
                    curl_setopt($CurlHandler, CURLOPT_USERPWD, $HTTPAuthUsername.':'.$HTTPAuthPassword);
                }

                $RemoteContent = curl_exec($CurlHandler);

                if (curl_error($CurlHandler) != '') {
                    return array(false, curl_error($CurlHandler));
                }

                curl_close($CurlHandler);

                return array(true, $RemoteContent);
            }
        }
    }
    
?>